/**
 * <copyright>
 * </copyright>
 *
 */
package com.habii.treasurehunt.treasurehunt.util;

import com.habii.treasurehunt.treasurehunt.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.habii.treasurehunt.treasurehunt.TreasurehuntPackage
 * @generated
 */
public class TreasurehuntAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static TreasurehuntPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TreasurehuntAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = TreasurehuntPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TreasurehuntSwitch<Adapter> modelSwitch =
    new TreasurehuntSwitch<Adapter>()
    {
      @Override
      public Adapter caseTreasureHunt(TreasureHunt object)
      {
        return createTreasureHuntAdapter();
      }
      @Override
      public Adapter caseAbstractElements(AbstractElements object)
      {
        return createAbstractElementsAdapter();
      }
      @Override
      public Adapter casePost(Post object)
      {
        return createPostAdapter();
      }
      @Override
      public Adapter casePlayer(Player object)
      {
        return createPlayerAdapter();
      }
      @Override
      public Adapter caseTeam(Team object)
      {
        return createTeamAdapter();
      }
      @Override
      public Adapter caseTask(Task object)
      {
        return createTaskAdapter();
      }
      @Override
      public Adapter caseClue(Clue object)
      {
        return createClueAdapter();
      }
      @Override
      public Adapter caseConfig(Config object)
      {
        return createConfigAdapter();
      }
      @Override
      public Adapter caseMobility(Mobility object)
      {
        return createMobilityAdapter();
      }
      @Override
      public Adapter caseOrder(Order object)
      {
        return createOrderAdapter();
      }
      @Override
      public Adapter caseTemporal(Temporal object)
      {
        return createTemporalAdapter();
      }
      @Override
      public Adapter caseDeadline(Deadline object)
      {
        return createDeadlineAdapter();
      }
      @Override
      public Adapter caseSocial(Social object)
      {
        return createSocialAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.TreasureHunt <em>Treasure Hunt</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.TreasureHunt
   * @generated
   */
  public Adapter createTreasureHuntAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.AbstractElements <em>Abstract Elements</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.AbstractElements
   * @generated
   */
  public Adapter createAbstractElementsAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Post <em>Post</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Post
   * @generated
   */
  public Adapter createPostAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Player <em>Player</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Player
   * @generated
   */
  public Adapter createPlayerAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Team <em>Team</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Team
   * @generated
   */
  public Adapter createTeamAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Task <em>Task</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Task
   * @generated
   */
  public Adapter createTaskAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Clue <em>Clue</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Clue
   * @generated
   */
  public Adapter createClueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Config <em>Config</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Config
   * @generated
   */
  public Adapter createConfigAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Mobility <em>Mobility</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Mobility
   * @generated
   */
  public Adapter createMobilityAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Order <em>Order</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Order
   * @generated
   */
  public Adapter createOrderAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Temporal <em>Temporal</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Temporal
   * @generated
   */
  public Adapter createTemporalAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Deadline <em>Deadline</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Deadline
   * @generated
   */
  public Adapter createDeadlineAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link com.habii.treasurehunt.treasurehunt.Social <em>Social</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see com.habii.treasurehunt.treasurehunt.Social
   * @generated
   */
  public Adapter createSocialAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //TreasurehuntAdapterFactory
