package com.habii.treasurehunt.framework.util;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.filechooser.FileFilter;

public class SampleFileFilter extends FileFilter {
	protected String description;

	protected ArrayList<String> exts = new ArrayList<String>();

	public void addType(String s) {
		exts.add(s);
	}

	/** Return true if the given file is accepted by this filter. */
	@Override
	public boolean accept(File f) {
		// Little trick: if you don't do this, only directory names
		// ending in one of the extentions appear in the window.
		if (f.isDirectory()) {
			return true;

		} else if (f.isFile()) {
			Iterator<String> it = exts.iterator();
			while (it.hasNext()) {
				if (f.getName().endsWith((String) it.next()))
					return true;
			}
		}

		// A file that didn't match, or a weirdo (e.g. UNIX device file?).
		return false;
	}

	/** Set the printable description of this filter. */
	public void setDescription(String s) {
		description = s;
	}

	/** Return the printable description of this filter. */
	public String getDescription() {
		return description;
	}

}
