/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.jscience.ecore.jscience;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.jscience.ecore.jscience.JscienceFactory
 * @model kind="package"
 * @generated
 */
public interface JsciencePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "jscience";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "platform:/plugin/org.jscience.ecore/model/jscience.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "jscience";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	JsciencePackage eINSTANCE = org.jscience.ecore.jscience.impl.JsciencePackageImpl.init();

	/**
	 * The meta object id for the '{@link org.jscience.ecore.jscience.impl.AllDatatypesImpl <em>All Datatypes</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.jscience.ecore.jscience.impl.AllDatatypesImpl
	 * @see org.jscience.ecore.jscience.impl.JsciencePackageImpl#getAllDatatypes()
	 * @generated
	 */
	int ALL_DATATYPES = 0;

	/**
	 * The feature id for the '<em><b>ELat Long</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALL_DATATYPES__ELAT_LONG = 0;

	/**
	 * The feature id for the '<em><b>EMoney</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALL_DATATYPES__EMONEY = 1;

	/**
	 * The number of structural features of the '<em>All Datatypes</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALL_DATATYPES_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '<em>ELat Long</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.jscience.geography.coordinates.LatLong
	 * @see org.jscience.ecore.jscience.impl.JsciencePackageImpl#getELatLong()
	 * @generated
	 */
	int ELAT_LONG = 1;

	/**
	 * The meta object id for the '<em>EMoney</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.jscience.physics.amount.Amount
	 * @see org.jscience.ecore.jscience.impl.JsciencePackageImpl#getEMoney()
	 * @generated
	 */
	int EMONEY = 2;


	/**
	 * Returns the meta object for class '{@link org.jscience.ecore.jscience.AllDatatypes <em>All Datatypes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>All Datatypes</em>'.
	 * @see org.jscience.ecore.jscience.AllDatatypes
	 * @generated
	 */
	EClass getAllDatatypes();

	/**
	 * Returns the meta object for the attribute '{@link org.jscience.ecore.jscience.AllDatatypes#getELatLong <em>ELat Long</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>ELat Long</em>'.
	 * @see org.jscience.ecore.jscience.AllDatatypes#getELatLong()
	 * @see #getAllDatatypes()
	 * @generated
	 */
	EAttribute getAllDatatypes_ELatLong();

	/**
	 * Returns the meta object for the attribute '{@link org.jscience.ecore.jscience.AllDatatypes#getEMoney <em>EMoney</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>EMoney</em>'.
	 * @see org.jscience.ecore.jscience.AllDatatypes#getEMoney()
	 * @see #getAllDatatypes()
	 * @generated
	 */
	EAttribute getAllDatatypes_EMoney();

	/**
	 * Returns the meta object for data type '{@link org.jscience.geography.coordinates.LatLong <em>ELat Long</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>ELat Long</em>'.
	 * @see org.jscience.geography.coordinates.LatLong
	 * @model instanceClass="org.jscience.geography.coordinates.LatLong"
	 * @generated
	 */
	EDataType getELatLong();

	/**
	 * Returns the meta object for data type '{@link org.jscience.physics.amount.Amount <em>EMoney</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>EMoney</em>'.
	 * @see org.jscience.physics.amount.Amount
	 * @model instanceClass="org.jscience.physics.amount.Amount<org.jscience.economics.money.Money>"
	 * @generated
	 */
	EDataType getEMoney();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	JscienceFactory getJscienceFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.jscience.ecore.jscience.impl.AllDatatypesImpl <em>All Datatypes</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.jscience.ecore.jscience.impl.AllDatatypesImpl
		 * @see org.jscience.ecore.jscience.impl.JsciencePackageImpl#getAllDatatypes()
		 * @generated
		 */
		EClass ALL_DATATYPES = eINSTANCE.getAllDatatypes();

		/**
		 * The meta object literal for the '<em><b>ELat Long</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ALL_DATATYPES__ELAT_LONG = eINSTANCE.getAllDatatypes_ELatLong();

		/**
		 * The meta object literal for the '<em><b>EMoney</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ALL_DATATYPES__EMONEY = eINSTANCE.getAllDatatypes_EMoney();

		/**
		 * The meta object literal for the '<em>ELat Long</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.jscience.geography.coordinates.LatLong
		 * @see org.jscience.ecore.jscience.impl.JsciencePackageImpl#getELatLong()
		 * @generated
		 */
		EDataType ELAT_LONG = eINSTANCE.getELatLong();

		/**
		 * The meta object literal for the '<em>EMoney</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.jscience.physics.amount.Amount
		 * @see org.jscience.ecore.jscience.impl.JsciencePackageImpl#getEMoney()
		 * @generated
		 */
		EDataType EMONEY = eINSTANCE.getEMoney();

	}

} //JsciencePackage
