/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.jscience.ecore.jscience.impl;

import javax.measure.unit.NonSI;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.jscience.economics.money.Money;
import org.jscience.ecore.jscience.*;

import org.jscience.geography.coordinates.LatLong;

import org.jscience.physics.amount.Amount;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class JscienceFactoryImpl extends EFactoryImpl implements
		JscienceFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public static JscienceFactory init() {
		try {
			JscienceFactory theJscienceFactory = (JscienceFactory)EPackage.Registry.INSTANCE.getEFactory("platform:/plugin/org.jscience.ecore/model/jscience.ecore"); 
			if (theJscienceFactory != null) {
				return theJscienceFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new JscienceFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public JscienceFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case JsciencePackage.ALL_DATATYPES: return createAllDatatypes();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case JsciencePackage.ELAT_LONG:
				return createELatLongFromString(eDataType, initialValue);
			case JsciencePackage.EMONEY:
				return createEMoneyFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case JsciencePackage.ELAT_LONG:
				return convertELatLongToString(eDataType, instanceValue);
			case JsciencePackage.EMONEY:
				return convertEMoneyToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AllDatatypes createAllDatatypes() {
		AllDatatypesImpl allDatatypes = new AllDatatypesImpl();
		return allDatatypes;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public LatLong createELatLongFromString(EDataType eDataType,
			String initialValue) {
		int pos = initialValue.indexOf(',');
		double lat = Double.valueOf(initialValue.substring(0, pos).trim());
		double lon = Double.valueOf(initialValue.substring(pos + 1).trim());
		return LatLong.valueOf(lat, lon, NonSI.DEGREE_ANGLE);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public String convertELatLongToString(EDataType eDataType,
			Object instanceValue) {
		LatLong latlong = (LatLong) instanceValue;
		return latlong.latitudeValue(NonSI.DEGREE_ANGLE) + ","
				+ latlong.longitudeValue(NonSI.DEGREE_ANGLE);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")
	public Amount<Money> createEMoneyFromString(EDataType eDataType,
			String initialValue) {
		return (Amount<Money>) Amount.valueOf(initialValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public String convertEMoneyToString(EDataType eDataType,
			Object instanceValue) {
		return super.convertToString(instanceValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public JsciencePackage getJsciencePackage() {
		return (JsciencePackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static JsciencePackage getPackage() {
		return JsciencePackage.eINSTANCE;
	}

} // JscienceFactoryImpl
