package org.jscience.xtext.valueconverters;

import org.eclipse.xtext.common.services.Ecore2XtextTerminalConverters;
import org.eclipse.xtext.conversion.IValueConverter;
import org.eclipse.xtext.conversion.ValueConverter;
import org.eclipse.xtext.conversion.ValueConverterException;
import org.eclipse.xtext.nodemodel.INode;
import org.jscience.economics.money.Money;
import org.jscience.ecore.jscience.JscienceFactory;
import org.jscience.ecore.jscience.JsciencePackage;
import org.jscience.geography.coordinates.LatLong;
import org.jscience.physics.amount.Amount;

public class JscienceValueConverters extends Ecore2XtextTerminalConverters {

	@ValueConverter(rule = "ELatLong")
	public IValueConverter<LatLong> ELatLong() {
		return new IValueConverter<LatLong>() {
			@Override
			public LatLong toValue(String string, INode node)
					throws ValueConverterException {
				return (LatLong) JscienceFactory.eINSTANCE.createFromString(JsciencePackage.eINSTANCE.getELatLong(), string);
			}

			@Override
			public String toString(LatLong value)
					throws ValueConverterException {
				return JscienceFactory.eINSTANCE.convertToString(JsciencePackage.eINSTANCE.getELatLong(), value);
			}
			
		};
	}

	@ValueConverter(rule = "EMoney")
	public IValueConverter<Amount<Money>> EMoney() {
		return new IValueConverter<Amount<Money>>() {
			@SuppressWarnings("unchecked")
			@Override
			public Amount<Money> toValue(String string, INode node)
					throws ValueConverterException {
				return (Amount<Money>) JscienceFactory.eINSTANCE.createFromString(JsciencePackage.eINSTANCE.getEMoney(), string);
			}
			
			@Override
			public String toString(Amount<Money> value)
					throws ValueConverterException {
				return JscienceFactory.eINSTANCE.convertToString(JsciencePackage.eINSTANCE.getEMoney(), value);
			}
			
		};
	}}
